/* Encodage arithmtique 
 * Optimis pour une arithmtique 16 bits
 */

#include <stdlib.h>
#include <string.h>
#include "arith.h"

static USHORT alow,ahigh;
static UCHAR *aoutbuf;
static UCHAR *apoutbuf,*aendbuf;
static UINT abufsize;
static UCHAR abitc;
static UINT ashifts;
static ABUFIO awritebuf;

void Arith_EncodeInit(ABUFIO writebuf,UCHAR *buf,UINT bufsize) {
	 
	 /* gestion du buffer */
	 aoutbuf=buf;
	 abufsize=bufsize;
	 memset(aoutbuf,0,abufsize);
	 apoutbuf=aoutbuf;
	 aendbuf=aoutbuf+abufsize;
	 awritebuf=writebuf;
	 abitc=0x80;

	 /* intervalle courant */
	 alow=0;
	 ahigh=0xFFFF;
	 
	 /* systme de gestion des retenues */
	 ashifts=0;
}

#define DIV16(a,b)		( (UINT)(a)/(UINT)(b) )
#define MUL16(a,b)		( (UINT)(a)*(UINT)(b) )


/*
 * Ecriture du buffer et mise  jour des pointeurs
 */
static void WriteBuf(void) {
		
	 if (apoutbuf>aoutbuf) awritebuf(aoutbuf,apoutbuf-aoutbuf);
	 memset(aoutbuf,0,abufsize);
	 apoutbuf=aoutbuf;
}
	 
	 
/*
 * Ecriture d'un bit  0
 */
static inline void PutBit0(void) {
	 
	 abitc=abitc>>1;
	 if ( abitc==0 ) { 
			abitc=0x80; 
			apoutbuf++; 
			if (apoutbuf>=aendbuf) WriteBuf();
	 }
}

/*
 * Ecriture d'un bit  1
 */

static inline void PutBit1(void)  {
	 
	 *apoutbuf|=abitc;
	 abitc=abitc>>1;
	 if ( abitc==0 ) { 
			abitc=0x80; 
			apoutbuf++; 
			if (apoutbuf>=aendbuf) WriteBuf();
	 }
}


void Arith_Encode(UINT amin,UINT amax,UINT asize) {
	USHORT range;

	range = ahigh - alow;
	if (amax!=asize) ahigh=alow+DIV16(MUL16(range,amax)+amax,asize)-1;
	if (amin!=0) alow+=DIV16(MUL16(range,amin)+amin,asize);
	 for ( ; ; ) {
			if (ahigh<0x8000) {
			 PutBit0();
			 while (ashifts!=0) {
					PutBit1();
					ashifts--;
			 }
		} else if (alow>=0x8000) {
			 PutBit1();
			 while (ashifts!=0) {
					PutBit0();
					ashifts--;
			 }
		} else if ( alow>=0x4000 && ahigh<0xC000 ) {
			ashifts++;  alow -= 0x4000;  ahigh -= 0x4000;
		} else break;
		alow+=alow;
		ahigh+=ahigh+1;
	}
}

void Arith_EncodeEnd(void)
{
	 ashifts++;
	 if (alow < 0x4000) {
		 PutBit0();
		 while (ashifts!=0) {
				PutBit1();
				ashifts--;
		 }													
	 } else {
			PutBit1();
			while (ashifts!=0) {
				 PutBit0();
				 ashifts--;
			}													
	 }
	 
	 if (abitc!=0x80) apoutbuf++;
	 WriteBuf();
}


