/*
 * Analyse de la ligne de commande " la GNU"
 * (c) 1995 Fabrice Bellard
 */

#include <stdlib.h>
#include <string.h>
#include "getopt.h"



/* recherche d'un nom de commande long et positionnement de arg aprs ce nom
 * s'il est trouv.
 * On accepte les noms de commande abbrgs si ce n'est pas ambigu.
 */
static GETOPT_REC *SearchLongName(GETOPT_REC *getopt_tab,char **arg)  {
	 GETOPT_REC *opt,*opt_found;
	 char *s,*r,*new_arg;
	 
	 opt=getopt_tab;
	 opt_found=NULL;
	 new_arg=*arg;
	 while (opt->long_name!=NULL)  {
			s=*arg;
			r=opt->long_name;
			while (1)  {
				 if (*s==0 || *s=='=')  {
						if (opt_found==NULL) { 
							 opt_found=opt;
							 new_arg=s;
							 break;
						} else {
							 return NULL;
						}
				 } else if (*r==0 || *r!=*s)  {
						break;
				 } else  {
						r++;
						s++;
				 }
			}
			opt++;
	 }
	 *arg=new_arg;
	 return opt_found;
}


/* Recherche un nom d'option court. Ici on prend le premier qui convient 
 * et on modifie arg qui pointe aprs.
 * Cela implique que getopt_tab doit tre tri de faon  faire apparaitre
 * les nom d'option courts en dernier.
 */
static GETOPT_REC *SearchShortName(GETOPT_REC *getopt_tab,char **arg)  {
	 GETOPT_REC *opt;
	 char *s,*r;
	 
	 opt=getopt_tab;
	 while (opt->long_name!=NULL)  {
			s=*arg;
			r=opt->short_name;
			if (r!=NULL)  {
				 while (1)  {
						if (*r==0)  {
							 *arg=s;
							 return opt;
						} else if (*r!=*s)  {
							 break;
						}
						r++;
						s++;
				 }
			}
			opt++;
	 }
	 return NULL;
}
						
				 

void GetOpt( int argc, char **argv, GETOPT_REC *getopt_tab, 
						GETOPT_FUNC getopt_func ) 
{
	 char *param,*arg,**arg_ptr;
	 int c;
	 GETOPT_REC *opt;
	 
	 arg_ptr=argv+1;
	 c=argc-1;

	 while (c>0)  {
			arg=*arg_ptr++;
			c--;
			if (*arg=='-') {
				 arg++;
				 if (*arg=='-')  {
						arg++;
						if (*arg=='\0')  {
							 /* si on rencontre "-- string" alors string est passe 
								* directement */
							 if (c!=0) {
									arg=*arg_ptr++;
									c--;
									getopt_func(GETOPT_ARG,NULL,arg);
							 }
						} else  {
							 /* option longue du type "--option" */
							 
							 opt=SearchLongName(getopt_tab,&arg);
							 
							 if (opt==NULL) {
									getopt_func(GETOPT_UNKNOWN,NULL,arg);
							 } else if (opt->param)  {
									if (*arg=='=')  {
										 /* paramtre du type "--option=param" */
										 arg++;
										 getopt_func(opt->option,opt,arg);
									} else  {
										 /* paramtre du type "--option param" */
										 
										 if (c==0) {
												getopt_func(GETOPT_EXPPARAM,opt,NULL);
										 } else  {
												arg=*arg_ptr++;
												c--;
												getopt_func(opt->option,opt,arg);
										 }
									}
							 } else  {
									/* pas de paramtre */
									if (*arg=='=')  {
										 getopt_func(GETOPT_NOPARAM,opt,NULL);
									} else  {
										 getopt_func(opt->option,opt,NULL);
									}
							 }
									
						}
				 } else  {
						/* paramtre court "-a" */
						if (*arg==0)  {
							 /* si on ne rencontre que "-", c'est un paramtre */
							 getopt_func(GETOPT_ARG,NULL,"-");
						} else  {
							 /* on gre aussi les cas du type: -c1c2 param1 param2 */
							 
							 while (*arg!=0) {
									opt=SearchShortName(getopt_tab,&arg);
									if (opt==NULL) {
										 getopt_func(GETOPT_UNKNOWN,NULL,arg);
										 break;
									} else if (opt->param)  {
										 if (c==0) {
												getopt_func(GETOPT_EXPPARAM,opt,NULL);
										 } else  {
												param=*arg_ptr++;
												c--;
												getopt_func(opt->option,opt,param);
										 }
									} else  {
										 getopt_func(opt->option,opt,NULL);
									}
							 }
						}
				 }
			} else  {
				 /* pas de "-", donc c'est un paramtre */
				 getopt_func(GETOPT_ARG,NULL,arg);
			}
	 }
}
									
			
			
			
			
			
			
	 
	 

