/*
 * Un parser le ligne de commande simplifie et portable
 * (c) 1995 Fabrice Bellard
 */

/* chaque option est dcrite dans une structure de donne */

typedef struct  {
	 char *long_name;    /* nom long de l'option (invocation du type --option) */
	 char *short_name;   /* nom court (invocation du type -o) */
	 int param;          /* !=0 si l'option admet un paramtre */
	 int option;         /* constante identifiant l'option (optionnel) */
} GETOPT_REC;


#define GETOPT_ARG      (-1)
#define GETOPT_UNKNOWN  (-2)
#define GETOPT_NOPARAM  (-3)
#define GETOPT_EXPPARAM (-4)

/* 
 * Procdure appele  chaque fois qu'une option ou valeur est rencontre
 * option dtermine le type d'argument rencontr:
 * GETOPT_UNKNOWN: option "arg" inconnue
 * GETOPT_EXPPARAM: paramtre de l'option "opt" attendu
 * GETOPT_NOPARAM: l'option "opt" ne demande pas de paramtre
 * GETOPT_ARG: un argument "arg" a t rencontr
 * GETOPREC.option: l'option "opt" a t rencontre
 */

typedef void (*GETOPT_FUNC)(int option,GETOPT_REC *opt,char *arg);


void GetOpt( int argc, char **argv, GETOPT_REC *opt, 
					 GETOPT_FUNC getopt_func );

